using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace ADX_Outlook_Advanced_Search_CS
{
	/// <summary>
	///   Add-in Express Add-in Module
	/// </summary>
	[GuidAttribute("DAFCAF60-818A-429F-A1D1-8A8CE1CB7149"), ProgId("ADX_Outlook_Advanced_Search_CS.AddinModule")]
	public class AddinModule : AddinExpress.MSO.ADXAddinModule
	{
		public AddinModule()
		{
			System.Windows.Forms.Application.EnableVisualStyles();
			InitializeComponent();
			// Please add any initialization code to the AddinInitialize event handler
		}

		private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
		private AddinExpress.OL.ADXOlFormsManager adxOlFormsManager1;
		internal AddinExpress.OL.ADXOlFormsCollectionItem adxOlFormsCollectionItem1;

		#region Component Designer generated code
		/// <summary>
		/// Required by designer
		/// </summary>
		private System.ComponentModel.IContainer components;

		/// <summary>
		/// Required by designer support - do not modify
		/// the following method
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            this.adxOlFormsManager1 = new AddinExpress.OL.ADXOlFormsManager(this.components);
            this.adxOlFormsCollectionItem1 = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.AdvancedSearchComplete += new AddinExpress.MSO.ADXHostActiveObject_EventHandler(this.adxOutlookEvents_AdvancedSearchComplete);
            this.adxOutlookEvents.AdvancedSearchStopped += new AddinExpress.MSO.ADXHostActiveObject_EventHandler(this.adxOutlookEvents_AdvancedSearchStopped);
            // 
            // adxOlFormsManager1
            // 
            this.adxOlFormsManager1.Items.Add(this.adxOlFormsCollectionItem1);
            this.adxOlFormsManager1.SetOwner(this);
            // 
            // adxOlFormsCollectionItem1
            // 
            this.adxOlFormsCollectionItem1.AlwaysShowHeader = true;
            this.adxOlFormsCollectionItem1.ExplorerItemTypes = AddinExpress.OL.ADXOlExplorerItemTypes.olMailItem;
            this.adxOlFormsCollectionItem1.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.BottomSubpane;
            this.adxOlFormsCollectionItem1.FolderName = "*";
            this.adxOlFormsCollectionItem1.FormClassName = "ADX_Outlook_Advanced_Search_CS.ADXOlForm1";
            // 
            // AddinModule
            // 
            this.AddinName = "ADX_Outlook_Advanced_Search_CS";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

		}
		#endregion

		#region Add-in Express automatic code

		// Required by Add-in Express - do not modify
		// the methods within this region

		public override System.ComponentModel.IContainer GetContainer()
		{
			if (components == null)
				components = new System.ComponentModel.Container();
			return components;
		}

		[ComRegisterFunctionAttribute]
		public static void AddinRegister(Type t)
		{
			AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
		}

		[ComUnregisterFunctionAttribute]
		public static void AddinUnregister(Type t)
		{
			AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
		}

		public override void UninstallControls()
		{
			base.UninstallControls();
		}

		#endregion

		public Outlook._Application OutlookApp
		{
			get
			{
				return (HostApplication as Outlook._Application);
			}
		}

		private void adxOutlookEvents_AdvancedSearchComplete(object sender, object hostObj)
		{
			Outlook.Results CurrentResults = null;
			Outlook.Search CurrentSearch = null;
			ADXOlForm1 myForm = adxOlFormsManager1.Items[0].GetCurrentForm(AddinExpress.OL.EmbeddedFormStates.Visible) as ADXOlForm1;
			if (myForm != null)
			{
				System.Windows.Forms.Cursor OldCursor = null;
				OldCursor = myForm.Cursor;
				try
				{
					myForm.Cursor = System.Windows.Forms.Cursors.WaitCursor;
					CurrentSearch = hostObj as Outlook.Search;
					if (CurrentSearch != null)
					{
						if (CurrentSearch.Tag == "Search1")
						{
							CurrentResults = CurrentSearch.Results;
							if (CurrentResults.Count > 0)
							{
								myForm.ListView1.BeginUpdate();
								object objItem = null;
								for (int i = 1; i <= CurrentResults.Count; i++)
								{
									objItem = CurrentResults[i];
									System.Windows.Forms.ListViewItem lvListItem = new System.Windows.Forms.ListViewItem();
									lvListItem.Text = objItem.GetType().InvokeMember(
										"SenderName", System.Reflection.BindingFlags.GetProperty, null, objItem, null).ToString();
									lvListItem.SubItems.Add(objItem.GetType().InvokeMember(
										"Subject", System.Reflection.BindingFlags.GetProperty, null, objItem, null).ToString());
									lvListItem.SubItems.Add(objItem.GetType().InvokeMember(
										"ReceivedTime", System.Reflection.BindingFlags.GetProperty, null, objItem, null).ToString());
									lvListItem.SubItems.Add(objItem.GetType().InvokeMember(
										"EntryID", System.Reflection.BindingFlags.GetProperty, null, objItem, null).ToString());
									myForm.ListView1.Items.Add(lvListItem);
								}
								if (myForm.ListView1.Items.Count > 0)
									myForm.ListView1.Items[0].Selected = true;
								myForm.ListView1.EndUpdate();
							}
							else
							{
								System.Windows.Forms.MessageBox.Show("0 items were found.");
							}
						}
					}
				}
				catch (Exception ex)
				{
					System.Windows.Forms.MessageBox.Show(ex.Message);
				}
				finally
				{
					if (CurrentResults != null) Marshal.ReleaseComObject(CurrentResults);
					myForm.Cursor = OldCursor;
				}
			}
		}

		private void adxOutlookEvents_AdvancedSearchStopped(object sender, object hostObj)
		{
			//
		}
	}
}

